﻿Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.ComponentModel

' To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line.
' <System.Web.Script.Services.ScriptService()> _
<System.Web.Services.WebService(Namespace:="http://mailcenter.cityshakes.com/")> _
<System.Web.Services.WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
<ToolboxItem(False)> _
Public Class mcmembers
    Inherits System.Web.Services.WebService

    <WebMethod()> _
    Public Function ValidateLogin(ByVal UserName As String, ByVal Password As String) As Boolean
        Dim vlduser = Membership.ValidateUser(UserName, Password)
        Return vlduser
    End Function

    <WebMethod()> _
    Public Function CreateNewUser(ByVal UserName As String, ByVal Password As String, ByVal UserEmail As String) As String
        Dim status As MembershipCreateStatus
        Try
            Dim newUser As MembershipUser = Membership.CreateUser(UserName, Password, UserEmail)
            If newUser Is Nothing Then
                Return GetErrorMessage(status)
            End If
            Return "ok"
        Catch ex As Exception
            Return ex.Message
        End Try
    End Function

    <WebMethod()> _
    Public Function AddUserToRole(ByVal UserName As String, ByVal newrole As String) As String
        Try
            Roles.AddUserToRole(UserName, newrole)
            Return "ok"
        Catch ex As Exception
            Return ex.Message
        End Try
    End Function

    <WebMethod()> _
    Public Function DeleteUser(ByVal UserName As String) As Boolean
        Return Membership.DeleteUser(UserName)
    End Function

    <WebMethod()> _
    Public Function RemoveUserFromRole(ByVal UserName As String, ByVal newrole As String) As String
        Try
            Roles.RemoveUserFromRole(UserName, newrole)
            Return "ok"
        Catch ex As Exception
            Return ex.Message
        End Try
    End Function

    <WebMethod()> _
    Public Function GetUserRoles(ByVal UserName As String) As String()
        Dim usrls = Roles.GetRolesForUser(UserName)
        Return usrls
    End Function

    <WebMethod()> _
    Public Function GetAllRoles() As String()
        Dim usrls = Roles.GetAllRoles
        Return usrls
    End Function

    <WebMethod()> _
    Public Function CreateRole(ByVal roleName As String) As String
        Try
            Roles.CreateRole(roleName)
            Return "ok"
        Catch ex As Exception
            Return ex.Message
        End Try
    End Function

    <WebMethod()> _
    Public Function GetAllUsers() As String()
        Dim memlist As String()
        ReDim memlist(0)
        For Each mmbr As MembershipUser In Membership.GetAllUsers
            ReDim Preserve memlist(memlist.Length)
            memlist(UBound(memlist)) = mmbr.UserName
        Next
        Return memlist
    End Function

    <WebMethod()> _
    Public Function GetUserInfo(ByVal UserName As String) As String()
        Dim memlist As String()
        ReDim memlist(3)
        Dim mmbr As MembershipUser = Membership.GetUser(UserName, False)
        memlist(0) = mmbr.UserName
        memlist(1) = "Password"
        memlist(2) = mmbr.Email
        Return memlist
    End Function

    Public Function GetErrorMessage(ByVal status As MembershipCreateStatus) As String

        Select Case status

            Case MembershipCreateStatus.DuplicateUserName
                Return "Username already exists. Please enter a different user name."

            Case MembershipCreateStatus.DuplicateEmail
                Return "A username for that e-mail address already exists. Please enter a different e-mail address."

            Case MembershipCreateStatus.InvalidPassword
                Return "The password provided is invalid. Please enter a valid password value."

            Case MembershipCreateStatus.InvalidEmail
                Return "The e-mail address provided is invalid. Please check the value and try again."

            Case MembershipCreateStatus.InvalidAnswer
                Return "The password retrieval answer provided is invalid. Please check the value and try again."

            Case MembershipCreateStatus.InvalidQuestion
                Return "The password retrieval question provided is invalid. Please check the value and try again."

            Case MembershipCreateStatus.InvalidUserName
                Return "The user name provided is invalid. Please check the value and try again."

            Case MembershipCreateStatus.ProviderError
                Return "The authentication provider returned an error. Please verify your entry and try again. If the problem persists, please contact your system administrator."

            Case MembershipCreateStatus.UserRejected
                Return "The user creation request has been canceled. Please verify your entry and try again. If the problem persists, please contact your system administrator."

            Case Else
                Return "An unknown error occurred. Please verify your entry and try again. If the problem persists, please contact your system administrator."
        End Select

    End Function

End Class